/*
 *  Copyright 2003-2014  Mikhail Kryshen <mikhail@kryshen.net>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.games1729.shariks;

//import java.util.*;
import java.io.*;

public abstract class Sharik implements Serializable {
    protected transient Field field = null;    
    SharikLook look;

    float m;                     // mass
    float drag = 10f;
    float vx = 0f, vy = 0f;      // velocity
    float ax, ay;                // acceleration
    float x, y;                  // location
    float r;                     // radius

    // used in Field.update()
    transient int cid;  // collision id
    transient float ct; // collision time

    public Sharik() {
    }

    public Sharik(Field field) {
	this.field = field;
    }       

    void setField(Field field) {
	this.field = field;
    }

    Vector2D getDrivingForce() {
	return new Vector2D(0, 0);
    }

    Vector2D getAttractingForce(Sharik s) {
	return new Vector2D(0, 0);
    }   

    public String toString() {
	return getClass().getName() + 
	    "[(" + x + "," + y + 
	    "),v=(" + vx + "," + vy + 
	    "),m=" + m + ",r=" + r + ")]";
    }

//     public void save(ObjectOutputStream out) throws IOException {
// 	out.writeShort(0);
// 	out.writeUTF(getClass().getName());
// 	out.writeFloat(m);
// 	out.writeFloat(drag);
// 	out.writeFloat(vx);
// 	out.writeFloat(vy);
// 	out.writeFloat(ax);
// 	out.writeFloat(ay);	
// 	out.writeFloat(x);
// 	out.writeFloat(y);	
// 	out.writeFloat(r);
// 	out.writeObject(look);
//     }

//     public static Sharik load(ObjectInputStream in, Field field) 
// 	throws IOException, ClassNotFoundException, IllegalAccessException,
// 	       NoSuchMethodException, InstantiationException,
// 	       java.lang.reflect.InvocationTargetException {

// 	String className = in.readUTF();
// 	Sharik sharik = (Sharik)Class.forName(className).
// 	    getConstructor(new Class[] {Field.class}).
// 	    newInstance(new Object[] {field});
// 	sharik.restore(in);
// 	return sharik;
//     }

//     public void restore(ObjectInputStream in) throws IOException, ClassNotFoundException {
// 	m = in.readFloat();
// 	drag = in.readFloat();
// 	vx = in.readFloat();
// 	vy = in.readFloat();
// 	ax = in.readFloat();
// 	ay = in.readFloat();	
// 	x = in.readFloat();
// 	y = in.readFloat();
// 	r = in.readFloat();
// 	look = (SharikLook)in.readObject();
//     }
}
