/*
 *  Copyright 2003-2014  Mikhail Kryshen <mikhail@kryshen.net>
 *
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.games1729.shariks;

class Vector2D {
    float x;
    float y;
    
    Vector2D(float x, float y) {
	this.x = x;
	this.y = y;
    }

    void add(Vector2D d) {
	x += d.x; y += d.y;
    }

    void sub(Vector2D d) {
	x -= d.x; y -= d.y;
    }

    void add(float dx, float dy) {
	x += dx; y += dy;
    }

    float getLength() {
	return (float)Math.sqrt(x * x + y * y);
    }

    void normalize() {
	float l = getLength();
	x /= l; y /= l;
    }
}
